#!/usr/local/bin/perl

##=======================================================================##
## AD-EDIT CORE v3.0.9
## (c)2008-2010 NorenzPRO Ltd. TakafumiArai 2010/10/2
##=======================================================================##
use CGI::Carp qw(fatalsToBrowser);

##=======================================================================##
## 設定項目
##=======================================================================##

##★ライブラリファイルのパス。
use strict;
use CGI;
use Encode;
require '../admin/aelib.cgi';

##★このスクリプトの名前
our $cginame = 'search.cgi';

##★ディレクトリファイルのパス
our $dirfile = '../admin/dir.dat';

##★システム設定ファイルのパス
our $servconf = '../admin/conf.dat';

##★検索ページの名前
our $PageTitle='サイト検索';

##=====================================================================================##
##メインルーチン
##=====================================================================================##

##ディレクトリファイル読込
open(DIRRD,"$dirfile");
our @DIR = <DIRRD>;
close(DIRRD);

##システム設定ファイル読込
open(CONFRD,"$servconf");
our @CONF = <CONFRD>;
close(CONFRD);
##文字コード判定→UTF8変換
my $contCC=&checkCharCode($servconf);
if ($contCC eq 'shiftjis') {
	foreach (@CONF) { Encode::from_to($_, 'shiftjis', 'utf8'); }
}
our $Domain =$CONF[3];
$Domain =~ s/\r//g; $Domain =~ s/\n//g;
our $RootPath =$CONF[10];
$RootPath =~ s/\r//g; $RootPath =~ s/\n//g;
our $SearchSkinURL =$CONF[15];
$SearchSkinURL =~ s/\r//g; $SearchSkinURL =~ s/\n//g;
our $pcoutCode =$CONF[22];
$pcoutCode =~ s/\r//g; $pcoutCode =~ s/\n//g;

if ($SearchSkinURL eq '') { $SearchSkinURL ='/skin/skin.html'; }
our $SkinFile='..'.$SearchSkinURL;
if ($pcoutCode eq '') { $pcoutCode='sjis'; }

##フォームの取得
our %in;
our @in;
my $query = CGI->new;
*in = $query->Vars();
if ($pcoutCode eq 'sjis') { foreach (%in) { Encode::from_to($_, 'shiftjis', 'utf8'); } }

$in{'q'} =~ s/\"/&quot;/g;
$in{'q'} =~ s/\'/&squot;/g;
$in{'q'} =~ s/</&lt;/g;
$in{'q'} =~ s/>/&gt;/g;

##==============メインアクション==============

our @PAGE;
our @PHEAD;
our @PFOOT;
our @SVCONF;
our $BaseRoot;

if ($in{'q'} ne '') {
	&Result;
} else {
	&ViewTag;
}
exit;

##=====================================================================================##
##サブルーチン
##=====================================================================================##
sub html_head {

#スキンページ読込
&page_read;

print "Content-type: text/html\n\n";
my $phi=0;
foreach (@PHEAD) {
	if ($pcoutCode eq 'sjis') { Encode::from_to($PHEAD[$phi], 'utf8', 'shiftjis'); }
	print $PHEAD[$phi];
	$phi++;
}

}
##=======================================================================================
sub html_foot {

#スキンページ読込
&page_read;

my $pfi=0;
foreach (@PFOOT) {
	if ($pcoutCode eq 'sjis') { Encode::from_to($PFOOT[$pfi], 'utf8', 'shiftjis'); }
	print $PFOOT[$pfi];
	$pfi++;
}

}
##=======================================================================================
sub ViewTag {

##検索ウィンドウ出力
my $htSearchForm = <<"htSearchForm";
<p>
<form action="$cginame" method="GET">
<input type="text" name="q">
<input type="submit" value="検索">
</form>
</p>
htSearchForm

&html_head;
$htSearchForm=$htSearchForm.'<h2>サイト検索</h2>'."\n";
if ($pcoutCode eq 'sjis') { Encode::from_to($htSearchForm, 'utf8', 'shiftjis'); }
print $htSearchForm;
&html_foot;

}
##=======================================================================================
sub Result {

my $TotalResult=0;

##データ読込
my $keywd=$in{'q'};
my $vkeywd=$in{'q'};
&dir_read;

&html_head;
my $tagBody= '<h2>検索結果</h2>'."\n";
if ($pcoutCode eq 'sjis') { Encode::from_to($tagBody, 'utf8', 'shiftjis'); }
print $tagBody;

##検索ウィンドウ出力
my $htSearchForm = <<"htSearchForm";
<p>
<form action="$cginame" method="GET" />
<input type="text" name="q" value="$vkeywd" />
<input type="submit" value="検索" />
</form>
</p>
htSearchForm
if ($pcoutCode eq 'sjis') { Encode::from_to($htSearchForm, 'utf8', 'shiftjis'); }
print $htSearchForm;

##検索結果一覧出力
print '<p><ul>'."\n";

my $di;
foreach (@DIR) {
	##INIT
	my $dirname='';
	my $editor='';
	my $level='';
	my $datafile='';
	my $PgTitle='';
	my @DB=();
	my @CF=();
	$CF[1]=''; $CF[3]=''; $CF[7]='';
	my @TRUE=();
	my @TERM=();
	my @LINE=();
	my %FILE;
	my $title;my $tFlag;my $kFlag;my $code;my $rslurl;
	my ($dirname,$editor,$level)=split(/\,/,$DIR[$di]);
	$dirname =~ s/\r//g; $dirname =~ s/\n//g;
	$editor =~ s/\r//g; $editor =~ s/\n//g;
	$level =~ s/\r//g; $level =~ s/\n//g;
	my $datafile='../'.$dirname.'/data.dat';
	my $conffile='../'.$dirname.'/conf.dat';

	##pgedit,pgedit2の検索処理
	if ((-e $datafile)&&($editor =~ /pgedit/)) {
		open(DBRD,"$datafile");
		@DB = <DBRD>;
		close(DBRD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($datafile);
		if ($contCC eq 'shiftjis') {
			foreach (@DB) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
		open(CFRD,"$conffile");
		@CF = <CFRD>;
		close(CFRD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($conffile);
		if ($contCC eq 'shiftjis') {
			foreach (@CF) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
		$CF[3] =~ s/\r//g; $CF[3] =~ s/\n//g;
		if ($CF[3] ne '') { $PgTitle=$CF[3].' ≫ '; }
		close(CFRD);
		@TRUE=grep(/\tshow=on\t/,@DB);
		@TERM=grep(/\tvSt=200001010000\tvFn=299912310000\t/,@TRUE);
		my $LotTERM=@TERM-1;my $li=0;
		for (0..$LotTERM) {
			@LINE=split(/\t/,$TERM[$li]);
			foreach (@LINE) {
				my ($key, $value) = split(/=/,$_);
				$value =~ s/\|eq\|/=/g;
				$FILE{$key} = $value;
			}
			if ($TERM[$li] !~ /\ttitle=\t/) { $title=$FILE{'title'}; $code=$FILE{'code'}; $tFlag=1; }
			if ($TERM[$li] =~ /$keywd/) { $kFlag=1; }
			if (($kFlag==1)&&($tFlag==1)&&($title ne '')&&($code ne '')) {
				$rslurl='../'.$dirname.'/index.cgi?mode=result&amp;code='.$code;
				my $tagBody= '<li><a href="'.$rslurl.'" target="_blank">'.$PgTitle.$title.'</a></li>';
				if ($pcoutCode eq 'sjis') { Encode::from_to($tagBody, 'utf8', 'shiftjis'); }
				print $tagBody;
				$TotalResult++;
				$tFlag=0;
				$kFlag=0;
				$title='';
				$code='';
				$rslurl='';
				$FILE{'title'}='';
			}
			$li++;
		}
	}
	##imgnavi,tmpedit,gmapの検索処理
	if (-e $datafile) {
	if (($editor eq 'imgnavi')||($editor eq 'tmpedit')||($editor eq 'gmap')) {
		open(DBRD,"$datafile");
		@DB = <DBRD>;
		close(DBRD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($datafile);
		if ($contCC eq 'shiftjis') {
			foreach (@DB) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
		open(CFRD,"$conffile");
		@CF = <CFRD>;
		close(CFRD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($conffile);
		if ($contCC eq 'shiftjis') {
			foreach (@CF) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
		if (($editor eq 'imgnavi')||($editor eq 'tmpedit')) {
			$CF[3] =~ s/\r//g; $CF[3] =~ s/\n//g;
			if ($CF[3] ne '') { $PgTitle=$CF[3].' ≫ '; }
		} elsif ($editor eq 'gmap') {
			$CF[7] =~ s/\r//g; $CF[7] =~ s/\n//g;
			if ($CF[7] ne '') { $PgTitle=$CF[7].' ≫ '; }
		}
		@TERM=grep(/\tshow=on\t/,@DB);
		my $LotTERM=@TERM-1;my $li=0;
		for (0..$LotTERM) {
			@LINE=split(/\t/,$TERM[$li]);
			foreach (@LINE) {
				my ($key, $value) = split(/=/,$_);
				$value =~ s/\|eq\|/=/g;
				$FILE{$key} = $value;
			}
			$code=$FILE{'code'};
			if ($TERM[$li] =~ /$keywd/) { $kFlag=1; }
			if (($kFlag==1)&&($code ne '')) {
				$title=$FILE{'title'};
				if ($title eq '') { $title='タイトル未設定'; }
				$rslurl='../'.$dirname.'/index.cgi?mode=result&amp;code='.$code;
				my $tagBody='<li><a href="'.$rslurl.'" target="_blank">'.$PgTitle.$title.'</a></li>';
				if ($pcoutCode eq 'sjis') { Encode::from_to($tagBody, 'utf8', 'shiftjis'); }
				print $tagBody;
				$TotalResult++;
				$kFlag=0;
			}
			$title='';
			$code='';
			$rslurl='';
			$FILE{'title'}='';
			$li++;
		}
	}}
	##hteditの検索処理
	my $htHit;
	if ((-e $datafile)&&($editor eq 'htedit')) {
		open(DBRD,"$datafile");
		@DB = <DBRD>;
		close(DBRD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($datafile);
		if ($contCC eq 'shiftjis') {
			foreach (@DB) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
		open(CFRD,"$conffile");
		@CF = <CFRD>;
		close(CFRD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($conffile);
		if ($contCC eq 'shiftjis') {
			foreach (@CF) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
		$CF[1] =~ s/\r//g; $CF[1] =~ s/\n//g;
		if ($CF[1] eq '') { $CF[1]='タイトル未設定'; }
		foreach (@DB) {
			if ($_ =~ /$keywd/) { $htHit=1; }
		}
		if ($htHit==1) {
			my $rslurl='../'.$dirname.'/index.cgi';
			my $tagBody='<li><a href="'.$rslurl.'" target="_blank">'.$CF[1].'</a></li>';
			if ($pcoutCode eq 'sjis') { Encode::from_to($tagBody, 'utf8', 'shiftjis'); }
			print $tagBody;
			$TotalResult++;
		}
		$rslurl='';
	}
	$di++;
}

if ($TotalResult==0) {
	my $tagBody='<li>ヒットした検索結果はありません</li>'."\n";
	if ($pcoutCode eq 'sjis') { Encode::from_to($tagBody, 'utf8', 'shiftjis'); }
	print $tagBody;
}
print '</ul></p>'."\n";

&html_foot;

}
##=======================================================================================
sub page_read {
	my $QRCodeS;
	my $QRCodeM;
	my $QRCodeL;
	my $alSkinFile;
	
	if ($RootPath ne '') { $BaseRoot='/'.$RootPath; } else { $BaseRoot=''; }
	$QRCodeS='<img src="http://adedit.norenz.net/qrcode/qr_img.cgi?d=http://'.$Domain.$BaseRoot.'/mobi/&amp;s=2" alt="QRコード" />';
	$QRCodeM='<img src="http://adedit.norenz.net/qrcode/qr_img.cgi?d=http://'.$Domain.$BaseRoot.'/mobi/&amp;s=3" alt="QRコード" />';
	$QRCodeL='<img src="http://adedit.norenz.net/qrcode/qr_img.cgi?d=http://'.$Domain.$BaseRoot.'/mobi/&amp;s=4" alt="QRコード" />';
	if (open(PAGEREAD,"$SkinFile")) {
		@PAGE = <PAGEREAD>;
		close(PAGEREAD);
		##文字コード判定→UTF8変換
		my $contCC=&checkCharCode($SkinFile);
		if ($contCC eq 'shiftjis') {
			foreach (@PAGE) { Encode::from_to($_, 'shiftjis', 'utf8'); }
		}
	} else {
		$alSkinFile=$SkinFile; $alSkinFile=~ s/\.\.//i;
		$PAGE[0] ='<html>'."\n";
		$PAGE[1] ='<head><meta http-equiv="Content-Type" content="text/html;charset=Shift_JIS"></head>'."\n";
		$PAGE[2] ='<body><h2 style="color:red">[設定]にて指定したスキンファイル ['.$alSkinFile.'] が存在しません</h2>'."\n";
		$PAGE[3] ='<span style="color:red">[設定]にて正しいスキンファイルを指定するか、[スキン編集]にて作成する必要があります</span>'."\n";
		$PAGE[4] ='<!-- MainZone -->'."\n";
		$PAGE[5] ='</body></html>'."\n";
	}
	#AD-EDITでメニューデータがあれば表示
	my $MenuFile='';my $mzi=1;
	my @MenuHTML='';my @MenuZone;
	for (0..99) {
		@MenuZone=();
		$MenuHTML[$mzi]='';
		$MenuFile='../admin/menu'.$mzi.'.inc';
		if (-e $MenuFile) {
			open(MENURD,"$MenuFile");
			@MenuZone = <MENURD>;
			close(MENURD);
			##文字コード判定→UTF8変換
			my $contCC=&checkCharCode($MenuFile);
			if ($contCC eq 'shiftjis') {
				foreach (@MenuZone) { Encode::from_to($_, 'shiftjis', 'utf8'); }
			}
			my $LotMenuLine=@MenuZone;
			my $mzline=0;
			for (0..$LotMenuLine) { $MenuHTML[$mzi]=$MenuHTML[$mzi].$MenuZone[$mzline].''; $mzline++; }
		} else { last; }
		$mzi++;
	}
	$mzi=$mzi-1;
	my $pageflag = 0;
	@PHEAD = (); @PFOOT = (); my $pi = 0;
	foreach (@PAGE) {
		if ($PAGE[$pi] =~ /MainZone/i) { $pageflag = 1; }
		my $mzj=1;
		for (0..$mzi) {
			$PAGE[$pi]=~ s/<MenuZone$mzj>/$MenuHTML[$mzj]/g;
			$mzj++;
		}
		$PAGE[$pi]=~ s/<QRCodeS>/$QRCodeS/g;
		$PAGE[$pi]=~ s/<QRCodeM>/$QRCodeM/g;
		$PAGE[$pi]=~ s/<QRCodeL>/$QRCodeL/g;
		$PAGE[$pi]=~ s/<\/title>/ - $PageTitle<\/title>/i;
		$PAGE[$pi]=~ s/<\/h1>/ - $PageTitle<\/h1>/i;
		if ($pageflag==0) { push(@PHEAD,$PAGE[$pi]); }
		if ($pageflag==1) { push(@PFOOT,$PAGE[$pi]); }
		$pi++;
	}
}
##=======================================================================================
sub dir_read {
	if (open(DIRRD,"$dirfile")) {
		@DIR = <DIRRD>;
		close(DIRRD);
	} else { &errorout('DIRファイルの読込に失敗しました。'); }
}
##=======================================================================================
sub errorout {

my $error = $_[0];

##★エラーメッセージの変更はここを訂正
my $errHTML = <<"ERRORMESS";
<span style="color:#ff0000">ERROR</span>
<div align="center">&nbsp;<br>$error</div>
ERRORMESS

print "Content-type: text/html\n\n";
if ($pcoutCode eq 'sjis') { Encode::from_to($errHTML, 'utf8', 'shiftjis'); }
print $errHTML;
exit;

}
##=======================================================================================
